# -*- Mode: rpm-spec -*-
# 	$Id: kernel-2.4.spec,v 1.2 2001/04/05 20:07:18 chmou Exp $	

%define sublevel 8
%define release 1mdk

# If you have the need to touch any of this something is very wrong with our
# numbering scheme
# FixMe:  
#   Why the hell we can't do a s/%kversion/%version/ as the rest of 
#   the packages?  
#      by the unexplained mysteries of the rpm.

%define kversion 2.4.%{sublevel}
%define KVERREL %{kversion}-%{release}

%define alsa_ver 0.5.11

%define build_up 1
%define build_smp 0

%define build_80 0 
%define build_boot 0

%ifarch %{ix86} ppc
%define build_pcmcia 0
%else
%define build_pcmcia 0
%endif

%ifarch %{ix86}
%define kgcc 1
%define build_enterprise 0

%else
%define kgcc 0
%define build_enterprise 0
%endif

# End of user definitions
%{?_without_up: %{expand: %%define build_up 0}}
%{?_without_smp: %{expand: %%define build_smp 0}}
%{?_without_enterprise: %{expand: %%define build_enterprise 0}}
%{?_without_kgcc: %{expand: %%define build_kgcc 0}}
%{?_with_up: %{expand: %%define build_up 1}}
%{?_with_smp: %{expand: %%define build_smp 1}}
%{?_with_enterprise: %{expand: %%define build_enterprise 1}}
%{?_with_kgcc: %{expand: %%define build_kgcc 1}}

%{?_with_80: %{expand: %%define build_80 1}}
%{?_with_BOOT: %{expand: %%define build_boot 1}}

# if you want to compile with other nice compiler, change the definition of
# the second kgcc
%if %{kgcc}
%define KCC /usr/bin/kgcc
%else
%define KCC /usr/bin/gcc
%endif

%define kmake %make CC=%{KCC}

%define alsa_name alsa-driver-%{alsa_ver}

Summary: The Linux kernel (the core of the Linux operating system).
Name: kernel-linus2.4
Version: %{kversion}
Release: %{release}
License: GPL
Group: System/Kernel and hardware
ExclusiveArch: %{ix86} alpha sparc sparc64 ppc
ExclusiveOS: Linux

####################################################################
#
# Sources
#
Source0: ftp://ftp.kernel.org/pub/linux/kernel/v2.4/linux-%{kversion}.tar.bz2
Source4: README.kernel-sources
Source7: ftp://ftp.alsa-project.org/pub/driver/%{alsa_name}.tar.bz2

Source13: rhkmvtag.c
Source14: kernel-2.4-BuildASM.sh
Source15: linux-mdkconfig.h
Source16: linux-merge-config.awk
Source17: linux-merge-modules.awk
Source18: boot_logo.ppm.bz2

Source20: kernel-%{kversion}-i586.config
Source22: kernel-%{kversion}-alpha.config
Source23: kernel-%{kversion}-ppc.config

####################################################################
#
# Patches
#

# Alsa patches
Patch5000: alsa-driver-0.5.11-compile-fix.patch.bz2 
# fixes #ifdef BLAH and (blah, ##bloh)
Patch5001: alsa-driver-0.5.11-compile-fix2.patch.bz2 

#END
####################################################################

# Defines for the things that are needed for all the kernels
%if %build_80
%define requires modutils >= 2.4.3-2mdk
%else
%define requires modutils >= 2.4.3-2mdk, devfsd
%define prereq initscripts >= 5.83-4mdk
%endif
%define provides kernel = %{kversion}, alsa

BuildRoot: %{_tmppath}/%{name}-%{kversion}-build
Provides: module-info, %provides
Autoreqprov: no
%if !%build_80
Prereq: %prereq
%endif
Requires: %requires
Obsoletes: alsa, hackkernel
BuildRequires: libbinutils2-devel, bison
%if !%build_80
BuildRequires: netpbm, libnetpbm-devel
%endif
%if %{kgcc}
BuildRequires: egcs, egcs-cpp
%else
BuildRequires: gcc, gcc-cpp
%endif

%define _builddir %{_topdir}/BUILD/%name/
%define __spec_prep_pre mkdir %_builddir||true

%description
The kernel package contains the Linux kernel (vmlinuz), the core of your
Linux Mandrake operating system.  The kernel handles the basic functions
of the operating system:  memory allocation, process allocation, device
input and output, etc.


#
# End packages - here begins build stage
#
%prep
%setup -q -n linux

# Patch party begins now

# Bring the Kernel Module Version Tag program
install -m644 %{SOURCE13} .

# Install bootlogo.
install -m644 %{SOURCE18} Documentation/

# make sure the kernel has the sublevel we know it has...
perl -p -i -e "s/^SUBLEVEL.*/SUBLEVEL = %{sublevel}/" Makefile

# 3rdparty modules
%ifos nolinux
%patch2000 -p1
%setup -q -n linux/3rdparty -D -T -a100
%setup -q -n linux/3rdparty -D -T -a101
%setup -q -n linux/3rdparty -D -T -a102
%setup -q -n linux/3rdparty -D -T -a103
%setup -q -n linux/3rdparty -D -T -a104
%patch2001 -p1
%patch2002 -p1
%endif

%setup -q -n linux -D -T

# alsa
%setup -q -n linux -D -T -a7
pushd %{alsa_name}
%patch5000 -p1
%patch5001 -p1
popd


# get rid of unwanted files
find . -name '*~' -o -name '*.orig'|xargs rm -f

###
### build
###

%build

# Common target directories
%define _kerneldir /usr/src/linux-%{kversion}
%define _bootdir /boot
%define _modulesdir /lib/modules
%define _savedheaders ../../savedheaders/

# Directories definition needed for building
%define temp_root %{_tmppath}/%{name}-%{version}
%define temp_source %{temp_root}%{_kerneldir}
%define temp_boot %{temp_root}%{_bootdir}
%define temp_modules %{temp_root}%{_modulesdir}

OptionChange () {
    type=$1
    feature=$2
    file=arch/%{_arch}/defconfig

    grep -q $feature $file || { echo "no $feature feature" && return 1 ;}
    
    cp -f $file config.tmp
    if [ $type = "disable" ]; then
	echo "Disabling option $feature"
	OPT="CONFIG_$feature" perl -e 'my $a = $ENV{'OPT'}; while (<>) {if (/^$a/) {print "# $a is not defined\n"; next;} print;}' \
	    < config.tmp > $file
    elif [ $type = "enable" ]; then
	echo "Enabling option $feature"
	OPT="CONFIG_$feature" perl -e 'my $a = $ENV{'OPT'}; while (<>) {if (/^#\s+$a/ || /^$a=m/) {print "$a=y\n"; next;} print;}' \
	    < config.tmp > $file
    elif [ $type = "module" ]; then
	echo "Modularize option $feature"
	OPT="CONFIG_$feature" perl -e 'my $a = $ENV{'OPT'}; while (<>) {if (/^#\s+$a/ || /^$a=y/) {print "$a=m\n"; next;} print;}' \
	    < config.tmp > $file
    fi
    rm -f config.tmp
}

OptionEnable() {
   feature=$1
   OptionChange enable $feature $file
}

OptionDisable() {
   feature=$1
   OptionChange disable $feature
}

DependKernel() {
	flavour=$1
	echo "Make dep for kernel $flavour"
	%kmake -s mrproper

	if [ "$flavour" = "enterprise" -o "$flavour" = "BOOT" ]; then
		configname="%{_target_cpu}-$flavour"
	else
		configname="%{_target_cpu}"
	fi

	install -m644 $RPM_SOURCE_DIR/kernel-%{kversion}-$configname.config arch/%{_arch}/defconfig
	rm -f .config
	if [ "$flavour" = "smp" ]; then
		OptionEnable  SMP
		OptionDisable FBCON_LOGO_BOOT
	elif [ "$flavour" = "up" ]; then
		OptionDisable SMP
#		OptionEnable  FBCON_LOGO_BOOT
	fi
	# we only want that for debug kernels
%if ! %build_boot
#	OptionDisable KDB
%endif

%if %build_80
	OptionDisable DEVFS_FS
	OptionDisable INET_ECN
	OptionDisable DRM_NEW
%endif
	# make sure ETXRAVERSION says what we want it to say
	if [ "$flavour" = "up" ]; then
		ext="linus"
	else
		ext=$flavour
	fi
	# make sure ETXRAVERSION says what we want it to say
	perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{release}$ext/" Makefile
	%kmake oldconfig
	%kmake dep
}

BuildKernel() {
	KernelVer=$1
	echo "Building kernel $KernelVer"
	
	%ifarch alpha
	%kmake boot
	%endif    

	%ifarch ppc
	%kmake vmlinux
	%endif

	%ifarch %{ix86}
	%kmake bzImage
	%endif

	%kmake modules

	# first make sure we are not loosing any .ver files to make mrporper's
	# removal of zero sized files.
	find include/linux/modules -size 0 | while read file ; do \
		echo > $file
	done

	## Start installing stuff
	install -d %{temp_boot}
	install -m 644 System.map %{temp_boot}/System.map-$KernelVer
	install -m 644 arch/%{_arch}/defconfig %{temp_boot}/config-$KernelVer

	%ifarch alpha
	cp -f arch/alpha/boot/vmlinux.gz %{temp_boot}//vmlinuz-$KernelVer
	%endif
	%ifarch ppc
	cp -f vmlinux %{temp_boot}/vmlinuz-$KernelVer
	%endif
	%ifarch %{ix86}
	cp -f arch/i386/boot/bzImage %{temp_boot}/vmlinuz-$KernelVer
	%endif

	# modules
	install -d %{temp_modules}/$KernelVer
	%kmake INSTALL_MOD_PATH=%{temp_root} KERNELRELEASE=$KernelVer modules_install 
    
	#Identify the modules directory with the Module Version Tag
	%{KCC} $RPM_OPT_FLAGS -o rhkmvtag rhkmvtag.c init/version.o
	./rhkmvtag > %{temp_modules}/$KernelVer/.rhkmvtag
	rm -f rhkmvtag
}

BuildPCMCIA() {
	KernelVer=$1
	# We need this directory created for the files section
	install -d %{temp_modules}/$KernelVer/pcmcia
%if %build_pcmcia
	echo "Building PCMCIA for $KernelVer ..."

	make -C %{pcmcia_name} clean
	pushd %{pcmcia_name}
	./Configure --noprompt \
		--kernel=$RPM_BUILD_DIR/linux \
		--cc=%{KCC} \
		--kcc=%{KCC} \
%ifarch ppc
		--kflags=-DCONFIG_ALL_PPC \
%endif
		--target=%{temp_root} \
		--trust \
		--cardbus \
		--nopnp \
		--srctree \
		--moddir=%{_modulesdir}/$KernelVer \
		--sysv \
		--rcdir=/etc/rc.d
	popd
	perl -pi -e 's|/usr/man|%{_mandir}|' %{pcmcia_name}/man/Makefile
# ppc needs make here, still investigating why
# FIXME
	make -C %{pcmcia_name} all
	make -C %{pcmcia_name} install
%endif
}

BuildAlsa() {
	KernelVer=$1
	AlsaRoot=%{temp_modules}/$KernelVer/alsa/
	echo "Building Alsa for $KernelVer"

        pushd %{alsa_name}
        [ -e Makefile.conf ] && make mrproper
	CFLAGS=$FLAGS CC=%{KCC} ./configure --with-kernel=$RPM_BUILD_DIR/linux \
		--with-moddir=$AlsaRoot \
		--with-processor=%{_target_cpu} \
		--with-smp=auto \
		--without-isapnp \
		--with-sequencer=yes \
		--with-oss=yes
	# Fix SMP build
	%make dep
	%make
	install -d $AlsaRoot
        install -m644 modules/*.o $AlsaRoot
	popd
}

SaveHeaders() {
	flavour=$1

	HeadersRoot=%{temp_source}/savedheaders
	HeadersArch=$HeadersRoot/%{_target_cpu}/$flavour
	echo "Saving hearders for $flavour %{_target_cpu}"

	# deal with the kernel headers that are version specific
	install -d $HeadersArch
	install -m 644 include/linux/autoconf.h $HeadersArch/autoconf.h
	install -m 644 include/linux/version.h $HeadersArch/version.h
	mv include/linux/modules $HeadersArch
    	echo "%{_target_cpu} $flavour %{_savedheaders}%{_target_cpu}/$flavour/" >> $HeadersRoot/list
}

CreateKernel() {
	flavour=$1
	if [ "$flavour" = "up" ]; then
		KernelVer=%{KVERREL}linus
	else
		KernelVer=%{KVERREL}$flavour
	fi
	DependKernel $flavour
	BuildKernel $KernelVer
	BuildPCMCIA $KernelVer
%if !%build_boot
	BuildAlsa $KernelVer
%endif
	SaveHeaders $flavour
}

###
# DO it...
###

# Create a simulacro of %buildroot
rm -rf %{temp_root}
install -d %{temp_root}

%if %build_boot
CreateKernel BOOT
exit 0
%endif

%if %build_smp
CreateKernel smp
%endif

%if %build_enterprise
CreateKernel enterprise
%endif

%if %build_up
CreateKernel up
%endif

# We don't make to repeat the depend code at the install phase
DependKernel up

###
### install
###
%install

# Directories definition needed for installing
%define target_source %{buildroot}/%{_kerneldir}
%define target_include %{buildroot}/usr/include
%define target_boot %{buildroot}%{_bootdir}
%define target_modules %{buildroot}%{_modulesdir}

# We want to be able to test several times the install part
rm -rf %{buildroot}
cp -a %{temp_root} %{buildroot}

%if %build_boot
exit 0
%endif

# Create directories infastructure
install -d %{buildroot}/sbin
install -d %{buildroot}%{_bindir}
install -d %{buildroot}%{_sbindir}
install -d %{buildroot}%{_sysconfdir}
install -d %{buildroot}/%{_mandir}/man{1,5,8}
install -d %{buildroot}%{_libdir}
install -d %{target_source} 
install -d %{target_include}
ln -sf ../src/linux/include/linux %{target_include}/linux

for i in %{target_modules}/*; do
  rm -f $i/build $i/modules.dep $i/modules.pcimap
  ln -sf %{_kerneldir} $i/build
done

install -d %{buildroot}%{_initrddir}
# End of lm_sensors

tar cf - . | tar xf - -C %{target_source}
ln -sf linux-%{kversion} %{buildroot}/usr/src/linux
install -m 644 %{SOURCE4}  %{target_source}

# generating headers file
ln -s ../src/linux/include/asm-generic %{target_include}/asm-generic
%ifarch sparc
ln -s ../src/linux/include/asm-sparc %{target_include}/asm-sparc
ln -s ../src/linux/include/asm-sparc64 %{target_include}/asm-sparc64
install -d %{target_include}/asm
cp  %{SOURCE14} %{target_source}/include/asm-sparc/BuildASM
%{target_include}/asm-sparc/BuildASM %{target_include}
%else
ln -sf ../src/linux/include/asm %{target_include}/asm
%endif

%if %build_pcmcia
install -d %{buildroot}/etc/pcmcia
install -d %{buildroot}/etc/sysconfig
# Install our own network up/down script
install -m755 %{SOURCE1000} %{buildroot}/etc/pcmcia/network
# We need our own default /etc/sysconfig/pcmcia
install -m755 %{SOURCE1001} %{buildroot}/etc/sysconfig/pcmcia
# We support now isdn pcmcia cards
install -m755 %{SOURCE1002} %{buildroot}/etc/pcmcia/isdn
#clean up the destination
%kmake clean -C %{target_source}/%{pcmcia_name}
rm -f %{target_source}/%{pcmcia_name}/config.out
%endif
%kmake -C %{target_source}/%{alsa_name} mrproper
for i in ainstr_gf1.h  ainstr_iw.h  ainstr_simple.h  asequencer.h  asound.h asoundid.h; do 
		cp -f %{target_source}/%{alsa_name}/include/$i \
				%{target_source}/include/linux/
done
rm -f %{target_source}/%{alsa_name}/include/config.h
rm -f %{target_source}/scripts/ppmtolinuxlogo

# We used to have a copy of DependKernel here
# Now, we make sure that the thing in the linux dir is what we want it to be

# We need to fix the patchs in .*depend files  after we fix the paths
find %{target_source} -name ".*depend" | \
while read file ; do
    mv $file $file.old
    sed -e "s|[^ ]*\(/usr/src/linux\)|\1|g" < $file.old > $file
    rm -f $file.old
done

# Try to put some smarter autoconf.h and version.h and modversions.h files in place
pushd %{target_source}/include/linux ; {
install -m 644 %{SOURCE15} rhconfig.h
rm -rf modules modversions.h autoconf.h version.h
# create modversions.h
cat > modversions.h <<EOF
#ifndef _LINUX_MODVERSIONS_H
#define _LINUX_MODVERSIONS_H
#include <linux/rhconfig.h>
#include <linux/modsetver.h>
EOF
list=`find %{_savedheaders}*/*/modules/*.ver -exec basename '{}' \; | sort -u`
mkdir modules
for l in $list; do
    sed 's,$,modules/'$l, %{_savedheaders}list | awk -f %{SOURCE17} > modules/$l
    touch -r modules/$l modules/`basename $l .ver`.stamp
    echo '#include <linux/modules/'$l'>' >> modversions.h
done
echo '#endif /* _LINUX_MODVERSIONS_H */' >> modversions.h
# Create autoconf.h file
echo '#include <linux/rhconfig.h>' > autoconf.h
sed 's,$,autoconf.h,' %{_savedheaders}list | awk -f %{SOURCE16} >> autoconf.h
# Create version.h
echo "#include <linux/rhconfig.h>" >> version.h
loop_cnt=0
for i in smp enterprise up; do
	if [ -d %{_savedheaders}%{_target_cpu}/$i -a \
	     -f %{_savedheaders}%{_target_cpu}/$i/version.h ]; then
		if [ $loop_cnt = 0 ]; then
      			buf="#if defined(__module__$i)"
      			previous_i="$i"
      			loop_cnt=1
    		else
      			echo "$buf" >> version.h
      			grep UTS_RELEASE %{_savedheaders}%{_target_cpu}/${previous_i}/version.h >> version.h
 	     		buf="#elif defined(__module__$i)"
      			previous_i="$i"
      			loop_cnt=`expr $loop_cnt + 1`
    		fi
    fi
done
#write last lines
if [ $loop_cnt -eq 0 ]; then
	echo "You need to build at least one kernel"
	exit 1;
fi

if [ $loop_cnt -gt 1 ]; then
	echo "#else" >> version.h
fi

grep UTS_RELEASE %{_savedheaders}%{_target_cpu}/${previous_i}/version.h >> version.h

if [ $loop_cnt -gt 1 ]; then
	echo "#endif" >> version.h
fi

# Any of the version.h are ok, as they only differ in the first line
ls %{_savedheaders}%{_target_cpu}/*/version.h | head -1 | xargs grep -v UTS_RELEASE >> version.h
rm -rf %{_savedheaders}
} ; popd
echo "#if 0" > %{target_boot}/kernel.h-%{kversion}

rm -f %{target_include}/linux
install -d %{target_include}/linux
cp -a %{target_source}/include/linux/* %{target_include}/linux/
rm -rf %{target_include}/linux/modules
echo "#error Modules should never use kernel-headers system headers," > %{target_include}/linux/modversions.h
echo "#error but headers from an appropriate kernel-source" >> %{target_include}/linux/modversions.h


# Generating asm headers
rm -f %{target_include}/asm-generic
install -d %{target_include}/asm-generic
cp -a %{target_source}/include/asm-generic/* %{target_include}/asm-generic/
%ifarch sparc
rm -f %{target_include}/asm-sparc
install -d %{target_include}/asm-sparc
cp -a %{target_source}/include/asm-sparc/* %{target_include}/asm-sparc/
rm -f %{target_include}/asm-sparc64
install -d %{target_include}/asm-sparc64
cp -a %{target_source}/include/asm-sparc64/* %{target_include}/asm-sparc64/
%else
rm -f %{target_include}/asm
install -d %{target_include}/asm
cp -a %{target_source}/include/asm/* %{target_include}/asm/
%endif

echo "GZIPPING Modules"
find %{target_modules} -name '*.o'|xargs gzip -9f

cat<<EOF>README.linus
The kernel package contains the Linux kernel (vmlinuz), the core of your
Linux Mandrake operating system.  The kernel handles the basic functions
of the operating system:  memory allocation, process allocation, device
input and output, etc.

This version of kernel is a version without any patch just the kernel
like Linus out of the press.
EOF
 

###
### clean
###

%clean
rm -rf %{buildroot}
rm -rf %{temp_root} 

###
### scripts
###

# do this for upgrades...in case the old modules get removed we have
# loopback in the kernel so that mkinitrd will work.
%preun
/sbin/modprobe loop 2> /dev/null > /dev/null
rm -f %{_modulesdir}/%{KVERREL}/modules.*
exit 0

%post
cd %{_bootdir}
if [ -x /sbin/installkernel ];then
	      /sbin/installkernel -a -c %{KVERREL}
fi
depmod -a -F %{_bootdir}/System.map-%{KVERREL} %{KVERREL}
%if %build_80
/usr/sbin/supermount -i disable
%endif

%postun
cd %{_bootdir}
if [ -f initrd-%{KVERREL}linus.img ];then
		rm -f initrd-%{KVERREL}linus.img
fi

if [ -f /etc/sysconfig/system ];then
		source /etc/sysconfig/system
		if [[ "$CLASS" = "beginner" ]];then
				/sbin/installkernel -a -R -c %{KVERREL}linus
		fi
fi

###
### file lists
###

%if %build_up
%files
%defattr(-,root,root)
%doc README.linus
%{_bootdir}/config-%{KVERREL}linus
%{_bootdir}/vmlinuz-%{KVERREL}linus
%{_bootdir}/System.map-%{KVERREL}linus
%{_modulesdir}/%{KVERREL}linus/kernel
%{_modulesdir}/%{KVERREL}linus/build
%{_modulesdir}/%{KVERREL}linus/pcmcia
%{_modulesdir}/%{KVERREL}linus/alsa
%endif

%changelog
* Thu Aug 16 2001 Thierry Vignaud <tvignaud@mandrakesoft.com> 2.4.8-1mdk
- remove logo (no patch at all)
- new release
- sync with main kernel spec
- add alsa (after all, it doesn't alter any kernel source bit)

* Tue Aug 07 2001 Thierry Vignaud <tvignaud@mandrakesoft.com> 2.4.7-1mdk
- enable to build more than a kernel at a time
- new release

* Mon Jul 16 2001 Thierry Vignaud <tvignaud@mandrakesoft.com> 2.4.6-3mdk
- add a README.linus

* Sun Jul 15 2001 Jeff Garzik <jgarzik@mandrakesoft.com> 2.4.6-2mdk
- update alpha config

* Wed Jul  4 2001 Jeff Garzik <jgarzik@mandrakesoft.com> 2.4.6-1mdk
- new release
- remove use of RPM_SOURCE_DIR (fix rpmlint errors)

* Thu Jun 21 2001 Stefan van der Eijk <stefan@eijk.nu> 2.4.5-2mdk
- BuildRequires: libgr-devel

* Tue Jun 19 2001 Thierry Vignaud <tvignaud@mandrakesoft.com> 2.4.5-1mdk
- new release

* Thu May 03 2001 Stefan van der Eijk <s.vandereijk@chello.nl> 2.4.4-2mdk
- update alpha .config

* Wed May 02 2001 Thierry Vignaud <tvignaud@mandrakesoft.com> 2.4.4-1mdk
- new version
- last %%post fix (which simplify the spec by the way)

* Fri Apr 13 2001 Thierry Vignaud <tvignaud@mandrakesoft.com> 2.4.3-2mdk
- remove documentation (already in kernel-doc)
- readd dead %%post
- update logo

* Mon Apr 02 2001 Thierry Vignaud <tvignaud@mandrakesoft.com> 2.4.3-1mdk
- new release
- fix buz.c compilation
- reduce the number of places where to alter release number

* Tue Mar 15 2001 Stefan van der Eijk <s.vandereijk@chello.nl> 2.4.2-2mdk
- update alpha + i586 .config

* Wed Feb 28 2001 Thierry Vignaud <tvignaud@mandrakesoft.com> 2.4.2-1mdk
- fix 6pack driver
- new stable version

* Wed Jan 31 2001 Stefan van der Eijk <s.vandereijk@chello.nl> 2.4.1-2mdk
- add alpha .config file

* Tue Jan 30 2001 Thierry Vignaud <tvignaud@mandrakesoft.com> 2.4.1-1mdk
- first release as requested by Chmouel
